searchNodes=[{"doc":"Uses the :erlang.statistics method to check the uptime of the Erlang VM and emits a :telemetry event with the most recent reading.","ref":"PrometheusTelemetry.PeriodicMeasurements.ErlangVM.html","title":"PrometheusTelemetry.PeriodicMeasurements.ErlangVM","type":"module"},{"doc":"","ref":"PrometheusTelemetry.PeriodicMeasurements.ErlangVM.html#periodic_measurements/0","title":"PrometheusTelemetry.PeriodicMeasurements.ErlangVM.periodic_measurements/0","type":"function"},{"doc":"","ref":"PrometheusTelemetry.PeriodicMeasurements.ErlangVM.html#vm_wall_clock/0","title":"PrometheusTelemetry.PeriodicMeasurements.ErlangVM.vm_wall_clock/0","type":"function"},{"doc":"PrometheusTelemetry PrometheusTelemetry is the plumbing for Telemetry.Metrics and allows the metrics passed in to be collected and exported in the format expected by the prometheus scraper. This supervisor also contains the ability to spawn an exporter which will scrape every supervisor running for metrics and will spin up a plug and return it at /metrics on port 4050 by default, this will work out of the box with umbrella apps as well and allow you to define metrics in each umbrella app Installation The package can be installed by adding prometheus_telemetry to your list of dependencies in mix.exs : def deps do [ { :prometheus_telemetry , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be found at https://hexdocs.pm/prometheus_telemetry . Example We can add this to any application we want: children = [ { PrometheusTelemetry , metrics : [ MyMetricsModule . metrics ( ) ] } ] Then to setup an exporter, on a server application like a phoenix app or pipeline we can setup the exporter which will start the metrics server (by default on port localhost:4050 ): children = [ { PrometheusTelemetry , exporter : [ enabled? : true ] , metrics : MyMetricsModule . metrics ( ) } ] Built in Metrics There are built in metrics for some erlang vm stats, phoenix, absinthe and ecto, to enable them we can use the following modules PrometheusTelemetry.Metrics.Ecto , PrometheusTelemetry.Metrics.Phoenix , PrometheusTelemetry.Metrics.GraphQL and PrometheusTelemetry.Metrics.VM children = [ { PrometheusTelemetry , exporter : [ enabled? : true ] , metrics : [ PrometheusTelemetry.Metrics.Ecto . metrics ( ) , PrometheusTelemetry.Metrics.Phoenix . metrics ( ) , PrometheusTelemetry.Metrics.GraphQL . metrics ( ) , PrometheusTelemetry.Metrics.VM . metrics ( ) ] } ] Defining Custom Metrics To define metrics we can create a module to group them like MyMetricsModule defmodule MyMetricsModule do import Telemetry.Metrics , only : [ last_value : 2 , counter : 2 ] def metrics do [ counter ( &quot;prometheus_name.to_save&quot; , # becomes prometheus_name_to_save in prometheus event_name : [ :event_namespace , :my_metric ] , # telemetry event name measurement : :count , # telemetry event metric description : &quot;some description&quot; ) , last_value ( &quot;my_custom.name&quot; , event_name : [ :event_namespace , :last_value ] , measurement : :total , description : &quot;my value&quot; , tags : [ :custom_metric ] # custom metrics to save, derived from :telemetry.execute metadata ) ] end def inc_to_save do :telemetry . execute ( [ :event_namespace , :my_metric ] , %{ count : 1 } ) end def set_custom_name do :telemetry . execute ( [ :event_namespace , :last_value ] , %{ total : 123 } , %{ custom_metric : &quot;region&quot; } ) end end Ultimately every list will get flattened which allows you to group metric modules under a single module such as defmodule GraphQL.Request do def metrics do ... end end defmodule GraphQL.Complexity do def metrics do ... end end defmodule GraphQL do def metrics , do : [ GraphQL.Complexity . metrics ( ) , GraphQL.Request . metrics ( ) ] end For more details on types you can check telemetry_metrics_prometheus_core Hiring Are you looking for a new gig?? We're looking for mid-level to senior level developers to join our team and continue growing our platform while building awesome software! Come join us at Blitz.gg &quot; Supported Options :name - Name for the prometheus telemetry supervisor The default value is :prometheus_telemetry . :exporter - Exporter config The default value is [enabled?: false, opts: []] . :enabled? - The default value is false . :opts - Exporter options The default value is [] . :port - Port to start the exporter on The default value is 4050 . :protocol - The default value is :http . :metrics - Metrics to start and aggregate that will ultimately end up in the exporter :periodic_measurements - Periodic metrics to start and aggregate that will ultimately end up in the exporter","ref":"PrometheusTelemetry.html","title":"PrometheusTelemetry","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"PrometheusTelemetry.html#child_spec/1","title":"PrometheusTelemetry.child_spec/1","type":"function"},{"doc":"","ref":"PrometheusTelemetry.html#get_metrics_string/0","title":"PrometheusTelemetry.get_metrics_string/0","type":"function"},{"doc":"","ref":"PrometheusTelemetry.html#get_metrics_string/1","title":"PrometheusTelemetry.get_metrics_string/1","type":"function"},{"doc":"","ref":"PrometheusTelemetry.html#list/0","title":"PrometheusTelemetry.list/0","type":"function"},{"doc":"","ref":"PrometheusTelemetry.html#list_prometheus_cores/1","title":"PrometheusTelemetry.list_prometheus_cores/1","type":"function"},{"doc":"","ref":"PrometheusTelemetry.html#poller_postfix/0","title":"PrometheusTelemetry.poller_postfix/0","type":"function"},{"doc":"","ref":"PrometheusTelemetry.html#start_link/1","title":"PrometheusTelemetry.start_link/1","type":"function"},{"doc":"This is the exporter for prometheus that sets up metrics to be scraped It uses /metrics as a route and is setup on port 4050 by default","ref":"PrometheusTelemetry.MetricsExporterPlug.html","title":"PrometheusTelemetry.MetricsExporterPlug","type":"module"},{"doc":"","ref":"PrometheusTelemetry.MetricsExporterPlug.html#child_spec/1","title":"PrometheusTelemetry.MetricsExporterPlug.child_spec/1","type":"function"},{"doc":"These metrics give you metrics around phoenix requests ecto.query.total_time ecto.query.decode_time ecto.query.query_time ecto.query.idle_time","ref":"PrometheusTelemetry.Metrics.Ecto.html","title":"PrometheusTelemetry.Metrics.Ecto","type":"module"},{"doc":"","ref":"PrometheusTelemetry.Metrics.Ecto.html#metrics/2","title":"PrometheusTelemetry.Metrics.Ecto.metrics/2","type":"function"},{"doc":"These metrics give you metrics around Absinthes GraphQL requests graphql.execute.duration.milliseconds graphql.subscription.duration.milliseconds graphql.resolve.duration.milliseconds graphql.middleware.batch.duration.milliseconds","ref":"PrometheusTelemetry.Metrics.GraphQL.html","title":"PrometheusTelemetry.Metrics.GraphQL","type":"module"},{"doc":"","ref":"PrometheusTelemetry.Metrics.GraphQL.html#metrics/0","title":"PrometheusTelemetry.Metrics.GraphQL.metrics/0","type":"function"},{"doc":"See PrometheusTelemetry.Metrics.GraphQL.Complexity.observe_complexity/2 .","ref":"PrometheusTelemetry.Metrics.GraphQL.html#observe_complexity/2","title":"PrometheusTelemetry.Metrics.GraphQL.observe_complexity/2","type":"function"},{"doc":"These metrics give you metrics around phoenix requests http_request.duration.microseconds phoenix.endpoint_call.duration.microseconds phoenix.controller_call.duration.microseconds phoenix.controller_error_rendered.duration.microseconds phoenix.channel_join.duration.microseconds_bucket phoenix.channel_receive.duration.microseconds","ref":"PrometheusTelemetry.Metrics.Phoenix.html","title":"PrometheusTelemetry.Metrics.Phoenix","type":"module"},{"doc":"","ref":"PrometheusTelemetry.Metrics.Phoenix.html#metrics/0","title":"PrometheusTelemetry.Metrics.Phoenix.metrics/0","type":"function"},{"doc":"These metrics give you some basic VM statistics from erlang, this includes: erlang.vm.memory erlang.vm.run_queue.total erlang.vm.run_queue.cpu erlang.vm.run_queue.io","ref":"PrometheusTelemetry.Metrics.VM.html","title":"PrometheusTelemetry.Metrics.VM","type":"module"},{"doc":"","ref":"PrometheusTelemetry.Metrics.VM.html#metrics/0","title":"PrometheusTelemetry.Metrics.VM.metrics/0","type":"function"}]